# To recompile run this script or with:
# mkimage -C none -A arm -T script -d boot.cmd boot.scr

setenv ramdisk initrd.img-6.1.73-v8
setenv kernel  vmlinuz-6.1.73-v8

if test ${devtype} != "usb"; then usb stop; sleep 1; fi
test "${loading_mmc}" = "" && setenv loading_mmc ${devnum}:${distro_bootpart}

if fdt addr -q ${fdt_addr}; then
   fdt move ${fdt_addr} ${fdt_addr_r}
else
   load mmc ${loading_mmc} ${fdt_addr_r} ${prefix}/${fdtfile}
fi
fdt addr ${fdt_addr_r}
fdt resize

setexpr fdtovaddr ${fdt_addr_r} + C0000

if test -n "${rootpath}"; then
  nfs ${ramdisk_addr_r} ${rootpath}${ramdisk}
  nfs ${kernel_addr_r} ${rootpath}${kernel}
  nfs ${fdtovaddr} ${rootpath}altboot.dtbo && setenv overlay 1
  ramdisk_size=3000000
  bootdev=${rootpath}
  setenv rootpath
else
  loaddev="${devtype} ${devnum}:${distro_bootpart}"
  load ${loaddev} ${ramdisk_addr_r} ${prefix}/${ramdisk} || load ${loaddev} ${ramdisk_addr_r} ${prefix}/${ramdisk}
  load ${loaddev} ${kernel_addr_r} ${prefix}/${kernel} || load ${loaddev} ${kernel_addr_r} ${prefix}/${kernel}
  load ${loaddev} ${fdtovaddr} ${prefix}/altboot.dtbo && setenv overlay 1
  setenv ramdisk_size 3000000
  bootdev=${devtype},${devnum},${distro_bootpart}
fi

if test -n "${overlay}"; then
  fdt resize 8192
  if fdt apply ${fdtovaddr}; then
      echo "Overlay OK"
  else
      setenv fdt_addr_r ${fdt_addr}
      fdt addr ${fdt_addr_r}
      fdt resize
  fi
fi

if test -n "${console}"; then setenv argconsole console=${console},${baudrate}; fi
if date tm; then setenv clock persistentclock=${tm}; fi
setenv bootargs root=/dev/ram0 ${argconsole} ${clock} ${extra} bootdev=${bootdev}
bootcount reset

booti ${kernel_addr_r} ${ramdisk_addr_r}:${ramdisk_size} ${fdt_addr_r}
